reflink: ensure that we can handle reflinking a lot of extents
[xfstests-dev.git] / tests / generic / 068
1 #! /bin/bash
2 # FSQA Test No. 068
3 #
4 # Test case to reproduce xfs_freeze hang under filsystem load.
5 # The fail case for this test is a hang on an xfs_freeze.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2000-2005 Silicon Graphics, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #
23 #-----------------------------------------------------------------------
24 #
25
26 seq=`basename $0`
27 seqres=$RESULT_DIR/$seq
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=0        # success is the default!
33
34 ITERATIONS=10
35
36 _cleanup()
37 {
38     cd /
39
40     trap 0 1 2 3 15
41     exit $status
42 }
43
44 trap "_cleanup" 0 1 2 3 15
45
46 # get standard environment, filters and checks
47 . ./common/rc
48 . ./common/filter
49
50 # real QA test starts here
51 _supported_fs generic
52 _supported_os Linux IRIX
53
54 _require_scratch
55 _require_freeze
56
57 echo "*** init FS"
58
59 rm -f $seqres.full
60 _scratch_unmount >/dev/null 2>&1
61 echo "*** MKFS ***"                         >>$seqres.full
62 echo ""                                     >>$seqres.full
63 _scratch_mkfs                               >>$seqres.full 2>&1 \
64     || _fail "mkfs failed"
65 _scratch_mount                              >>$seqres.full 2>&1 \
66     || _fail "mount failed"
67
68 touch $tmp.running
69
70 # start fsstress loop in a background block
71 {
72     STRESS_DIR="$SCRATCH_MNT/fsstress_test_dir"
73     mkdir "$STRESS_DIR"
74
75     procs=2
76     nops=200
77     while [ -f "$tmp.running" ]
78       do
79       # We do both read & write IO - not only is this more realistic,
80       # but it also potentially tests atime updates
81       FSSTRESS_ARGS=`_scale_fsstress_args -d $STRESS_DIR -p $procs -n $nops $FSSTRESS_AVOID`
82       $FSSTRESS_PROG $FSSTRESS_ARGS > /dev/null 2>&1
83     done
84
85     rm -r $STRESS_DIR/*
86     rmdir $STRESS_DIR
87 } &
88
89 # start fstest -m loop in a background block; this gets us mmap coverage
90 {
91     FSTEST_DIR="$SCRATCH_MNT/fstest_test_dir"
92     mkdir "$FSTEST_DIR"
93
94     procs=2
95     while [ -f "$tmp.running" ]
96       do
97       src/fstest -m -p $FSTEST_DIR  -n $procs -f 4 > /dev/null 2>&1
98     done
99
100     rm -rf $FSTEST_DIR/*
101     rmdir $FSTEST_DIR
102 } &
103
104 i=0
105 let ITERATIONS=$ITERATIONS-1
106
107 echo | tee -a $seqres.full
108 while [ $i -le $ITERATIONS ]
109 do
110         echo "*** iteration: $i" | tee -a $seqres.full
111         echo "*** freezing \$SCRATCH_MNT" | tee -a $seqres.full
112         xfs_freeze -f "$SCRATCH_MNT" | tee -a $seqres.full
113         [ $? != 0 ] && echo xfs_freeze -f "$SCRATCH_MNT" failed | \
114             tee -a $seqres.full
115         sleep 2
116
117         echo "*** thawing  \$SCRATCH_MNT" | tee -a $seqres.full
118         xfs_freeze -u "$SCRATCH_MNT" | tee -a $seqres.full
119         [ $? != 0 ] && echo xfs_freeze -u "$SCRATCH_MNT" failed | \
120             tee -a $seqres.full
121         sleep 2
122
123         echo  | tee -a $seqres.full
124         let i=$i+1
125 done
126
127 # stop fsstress iterations
128 rm $tmp.running
129
130 # wait for fsstresses to finish
131 wait
132
133 exit 1